#! /usr/bin/env python
# coding: Utf-8

base = u"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz"
bold = u"𝐀𝐁𝐂𝐃𝐄𝐅𝐆𝐇𝐈𝐉𝐊𝐋𝐌𝐍𝐎𝐏𝐐𝐑𝐒𝐓𝐔𝐕𝐖𝐗𝐘𝐙𝐚𝐛𝐜𝐝𝐞𝐟𝐠𝐡𝐢𝐣𝐤𝐥𝐦𝐧𝐨𝐩𝐪𝐫𝐬𝐭𝐮𝐯𝐰𝐱𝐲𝐳"
ital = u"𝐴𝐵𝐶𝐷𝐸𝐹𝐺𝐻𝐼𝐽𝐾𝐿𝑀𝑁𝑂𝑃𝑄𝑅𝑆𝑇𝑈𝑉𝑊𝑋𝑌𝑍𝑎𝑏𝑐𝑑𝑒𝑓𝑔ℎ𝑖𝑗𝑘𝑙𝑚𝑛𝑜𝑝𝑞𝑟𝑠𝑡𝑢𝑣𝑤𝑥𝑦𝑧"
both = u"𝑨𝑩𝑪𝑫𝑬𝑭𝑮𝑯𝑰𝑱𝑲𝑳𝑴𝑵𝑶𝑷𝑸𝑹𝑺𝑻𝑼𝑽𝑾𝑿𝒀𝒁𝒂𝒃𝒄𝒅𝒆𝒇𝒈𝒉𝒊𝒋𝒌𝒍𝒎𝒏𝒐𝒑𝒒𝒓𝒔𝒕𝒖𝒗𝒘𝒙𝒚𝒛"

smal = u"abcdefghijklmnopqrstuvwxyzœæ"
caps = u"ᴀʙᴄᴅᴇꜰɢʜɪᴊᴋʟᴍɴᴏᴘqʀꜱᴛᴜᴠᴡxʏᴢɶᴁ"

pilf = u"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz?!⸘&æœ,'"
flip = u"ⱯᗺƆᗡƎℲ⅁HIſꞰꞀꟽИOdꝹᴚS⊥⋂ɅMX⅄Zɐqɔpǝɟƃɥıɾʞןɯuodbɹsʇnʌʍxʎz¿¡‽⅋ᴂᴔ‘,"

adds = (u"∀∃∄∧∨≠≡≢≃≄∪∩⋃⋂⊂⊆⊄⊈≥≤∈∉∫√∞∅∕÷¬⋅×“”„«»  ←↑→↓ß…¿¡‽⊤⊥¹²³⁴⁵⁶⁷⁸⁹⁰⁽⁾⁺⁻⁼"
        u"ΑΒΓΔΕΖΗΘΙΚΛΜΝΞΟΠΡΣΤΥΦΧΨΩαβγδεζηθικλμνξοπρςστυφχψωÆæŒœ"
        u"♪♫𝄞𝄢♯♭♮☺😊😎😇😈💔💗💕⚡⚠✔✗♻♀♂☮☐☑☒☢☣©®™")

alls = set(base+smal+caps+bold+ital+both+adds+u" ?;.:!$€£&+=-–—%#§/\|{}[]()")

import sys, optparse
parser = optparse.OptionParser()
parser.add_option("-d", "--delete", dest="delete", action="store_true",
    default=False, help="press the Delete key at startup")
parser.add_option("-s", "--strike", dest="strike", action="store_true",
    default=False, help="apply stroke text at startup")
parser.add_option("-b", "--bold", dest="bold", action="store_true",
    default=False, help="apply bold text at startup")
parser.add_option("-i", "--italic", dest="italic", action="store_true",
    default=False, help="apply italic text at startup")
parser.add_option("-u", "--underline", dest="underline", action="store_true",
    default=False, help="apply underlined text at startup")
parser.add_option("-m", "--mirror", dest="mirror", action="store_true",
    default=False, help="apply mirrored text at startup")
parser.add_option("-c", "--caps", "--small-caps", dest="caps",
    action="store_true", default=False, help="apply small caps at startup")
parser.add_option("-r", "--read", "--stdin", "--standard-input",
    dest="stdin", action="store_true", default=False,
    help="read the original text from the standard input")
parser.add_option("-n", "--no-atspi", "--no-pyatspi",
    dest="pyatspi", action="store_false", default=True,
    help="disable pyatspi (allow direct Enter)")
parser.add_option("-2", "--gtk2", "--pygtk", "--gtk-2.0", "--oldschool",
    dest="gtk2", action="store_true", default=False,
    help="use PyGTK (GTK2 rather than GTK3, Python 2 only)")
parser.add_option("-g", "--geom", "--geometry", action="store",
    dest="geometry", default=None, help="size and position for the popup")
parser.formatter.format_epilog = lambda x: x
parser.epilog = u"""
Once the editor popup is opened:
– press Enter to directly paste the current text using pyatspi
– press Ctrl+Enter to insert a new linebreak in the editor
– press Ctrl+D to set the current text in the PRIMARY clipboard
– press Esc. to set the original text in the PRIMARY clipboard
– press Ctrl+C (when no text selected in the popup) to set the current
\ttext in the CLIPBOARD and the original one in the PRIMARY
– clic the middle button out of the popup to PRIMARY paste the current text
– clic the right button out of the popup to PRIMARY paste the original text
– clic any other button out of the popup to set the original text in the PRIMARY
Any of those actions (Ctrl+Enter excepted) will also close the popup.
"""
options, args = parser.parse_args()

import unicodedata
import Xlib.XK, Xlib.display
disp = Xlib.display.Display()

if options.gtk2:
    try:
        import gtk, glib
        from gtk import gdk
    except ImportError:
        options.gtk2 = False
if not options.gtk2:
    import gi  # The new version…
    gi.require_version("Gtk", "3.0")
    from gi.repository import Gtk as gtk
    from gi.repository import Gdk as gdk
    from gi.repository import GLib as glib

clip = (gtk.clipboard_get("PRIMARY") if options.gtk2 else
        gtk.Clipboard.get(gdk.Atom.intern_static_string("PRIMARY")))
text = sys.stdin.read() if options.stdin else clip.wait_for_text()
buff = gtk.TextBuffer()

if options.pyatspi:
    try: import pyatspi
    except ImportError:
        pyatspi = None
else: pyatspi = None

if text is not None:
    buff.set_text(text)
    if options.delete:
        keysym = Xlib.XK.string_to_keysym("Delete")
        keycode = disp.keysym_to_keycode(keysym)
        Xlib.ext.xtest.fake_input(disp, Xlib.X.KeyPress, keycode)
        Xlib.ext.xtest.fake_input(disp, Xlib.X.KeyRelease, keycode)
        disp.flush()

def _done(clip, event):
    if not popup.get_visible():
        glib.timeout_add(250, gtk.main_quit)

def _grab(popup):
    popup.grab_add()
    if options.gtk2:
        gtk.gdk.keyboard_grab(popup.window, True)
        gtk.gdk.pointer_grab(popup.window, True, gtk.gdk.BUTTON_PRESS_MASK)
    else:  # GTK 3.
        seat = popup.get_display().get_default_seat()
        seat.grab(popup.get_window(), gdk.SeatCapabilities.ALL, True,None,None)
    if options.geometry is None or all(x not in options.geometry for x in "+-"):
        pointer = gdk.get_default_root_window().get_pointer()
        x,y = pointer[0:2] if options.gtk2 else pointer[1:3]
        w,h = popup.get_size()
        popup.move(x-w/2, y-h/2)
    edit.grab_focus()

def _keys(widget, event):
    cmask = gdk.CONTROL_MASK if options.gtk2 else gdk.ModifierType.CONTROL_MASK
    if event.keyval == 65307:  # Esc.
        if text is not None:
            clip.set_text(text, -1)
        glib.timeout_add(100, popup.destroy)
    elif event.keyval == 65293:  # Enter.
        if event.state & cmask != cmask:
            if pyatspi != None:
                glib.timeout_add(150, _asend)
                popup.destroy()
                return True
    elif event.keyval in (67, 99):  # C.
        if event.state & cmask == cmask:
            if len(buff.get_selection_bounds()) > 0:
                return False  # Copy only the selection.
            if text is not None:
                clip.set_text(text, -1)
            c = (gtk.clipboard_get("CLIPBOARD") if options.gtk2 else
                gtk.Clipboard.get(gdk.Atom.intern_static_string("CLIPBOARD")))
            c.set_text(buff.get_text(buff.get_start_iter(),
                       buff.get_end_iter(), False), -1)
            glib.timeout_add(100, popup.destroy)
    elif event.keyval in (68, 100):  # D.
        if event.state & cmask == cmask:
            clip.set_text(buff.get_text(buff.get_start_iter(),
                          buff.get_end_iter(), False), -1)
            glib.timeout_add(100, popup.destroy)
    elif event.keyval == 65056:  # BackTab.
        tv.grab_focus()
        return True

def _mouse(window, event):
    x,y = window.get_position()
    width,height = window.get_size()
    if (event.y_root < y or event.y_root > y+height
     or event.x_root < x or event.x_root > x+width):
        if event.button == 2:
            clip.set_text(buff.get_text(buff.get_start_iter(),
                          buff.get_end_iter(), False), -1)
        elif text is not None:
            clip.set_text(text, -1)
        glib.timeout_add(100, popup.destroy)
        if event.button in (2, 3):
            glib.timeout_add(150, _xsend)

def _xsend():
    Xlib.ext.xtest.fake_input(disp, Xlib.X.ButtonPress, 2)
    Xlib.ext.xtest.fake_input(disp, Xlib.X.ButtonRelease, 2)
    disp.flush()

def _asend():
    res = buff.get_text(buff.get_start_iter(), buff.get_end_iter(), False)
    pyatspi.Registry().generateKeyboardEvent(0, res, pyatspi.KEY_STRING)

def _apply(button, modfunc, *args):
    bounds = buff.get_selection_bounds()
    selection = len(bounds) > 0
    if not selection:
        bounds = buff.get_bounds()
    text = buff.get_text(bounds[0], bounds[1], False)
    if type("") != type(u""):  # Compatibility Python 2.
        text = text.decode("utf-8")
    if selection:
        buff.delete_selection(True, True)
        buff.insert_at_cursor(modfunc(text, *args))
    else: buff.set_text(modfunc(text, *args))

def _over(text, ov):
    return u"".join(char+ov if char in alls else char for char in text)

def _conv(text, convs):
    result = u""
    for char in text:
        found = False
        for origins in convs.keys():
            if char in origins:
                result += convs[origins][origins.index(char)]
                found = True
                break
            norm = unicodedata.normalize("NFKD", char)
            if any(char in origins for char in norm):
                found = True
                for char in norm:
                    if char in origins:
                        result += convs[origins][origins.index(char)]
                    else: result += char
                break
        if not found:
            result += char
    return result

def _mirror(text):
    return _conv(text, {pilf: flip, flip: pilf})[::-1]

def _addit(tv, path, col):
    buff.insert_at_cursor(model[path][0])

popup = gtk.Window(gtk.WINDOW_POPUP if options.gtk2 else gtk.WindowType.POPUP)
popup.connect("button-press-event", _mouse)
clip.connect("owner-change", _done)
popup.connect("show", _grab)
vbox = gtk.VBox(False, 0)
hbox = gtk.HBox(True, 0)
vbox.pack_start(hbox, *[False]*(2 if options.gtk2 else 3))

for form in [(options.italic, _conv, {base: ital, bold: both}),
             (options.bold, _conv, {base: bold, ital: both}),
             (options.underline, _over, u"̲"),
             (options.strike, _over, u"̶"),
             (options.caps, _conv, {smal: caps}),
             (options.mirror, _mirror)]:
    button = gtk.Button(form[1]("a", *form[2:]))
    button.connect("clicked", _apply, *form[1:])
    button.set_focus_on_click(False)
    hbox.add(button)
    if form[0]:
        button.clicked()

paned = gtk.HPaned()
vbox.add(paned)
edit = (gtk.TextView(buff) if options.gtk2 else
        gtk.TextView.new_with_buffer(buff))
edit.connect("key-press-event", _keys)
scroll = gtk.ScrolledWindow()
if options.gtk2:
    scroll.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
scroll.add(edit)
paned.add2(scroll)
model = gtk.ListStore(str)
for char in adds:
    model.append([char])
tv = gtk.TreeView(model) if options.gtk2 else gtk.TreeView.new_with_model(model)
tv.set_headers_visible(False)
tvc = gtk.TreeViewColumn(None)
cell = gtk.CellRendererText()
tvc.pack_start(cell, True)
tvc.add_attribute(cell, 'text', 0)
tv.append_column(tvc)
tv.set_row_separator_func(lambda model, path: model[path][0] is None)
tv.connect("row-activated", _addit)
scroll = gtk.ScrolledWindow()
if options.gtk2:
    scroll.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
scroll.add(tv)
paned.add1(scroll)
frame = gtk.Frame()
frame.add(vbox)
popup.add(frame)

if options.geometry is not None:
    frame.show_all()
    popup.parse_geometry(options.geometry)

popup.show_all()
gtk.main()
